// Name
// Student ID

// A global list of colours taken from the online
// Rush Hour game, just to give our rectangular
// cars a bit of character.
color[] colour_map = {
  color( 250, 66, 56 ),
  color( 190, 247, 26 ),
  color( 217, 3, 244 ),
  color( 252, 250, 61 ),
  color( 250, 150, 1 ),
  color( 4, 210, 250 ),
  color( 247, 75, 152 ),
  color( 151, 250, 231 ),
  color( 244, 77, 235 ),
  color( 98, 169, 192 ),
  color( 240, 243, 180 ),
  color( 251, 250, 63 )
};

// A global array of all the cars in the game.
Car[] cars;

void setup()
{
  size( 400, 400 );
  
  // Use the ideas from Module 02 to read in 
  // a description of a puzzle from an external
  // file.  Each line in the file contains
  // the (x,y) coordinates of the top-left
  // corner of a car, followed by its width 
  // and height.  We'll stretch everything out
  // by a factor of 50 to make it visible on the
  // screen.
  String[] lines = loadStrings( "puzzle.txt" );
  
  // We need an array whose size is the number of
  // cars described in the puzzle file.
  cars = new Car[lines.length];
  
  for( int idx = 0; idx < cars.length; ++idx ) {
    // Get the idx'th car from the corresponding
    // line in the input file.
    int[] nums = int( splitTokens( lines[idx] ) );
    cars[idx] = new Car( 50*nums[0] + 50, 50*nums[1]+50, 50*nums[2], 50*nums[3] );
    cars[idx].setColour( colour_map[idx] );
  }
}

void draw()
{
  background( 50 );
  noFill();
  stroke( 255 );
  rect( 45, 45, 310, 310 );
  stroke( 0 );
  
  for( Car c : cars ) {
    c.draw();
  }
}